'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.PULSE_EVENT = undefined;

var _audioContext = require('audio-context');

var _audioContext2 = _interopRequireDefault(_audioContext);

var _unixTimestamp = require('unix-timestamp');

var _unixTimestamp2 = _interopRequireDefault(_unixTimestamp);

var _getusermedia = require('getusermedia');

var _getusermedia2 = _interopRequireDefault(_getusermedia);

var _wolfy87Eventemitter = require('wolfy87-eventemitter');

var _wolfy87Eventemitter2 = _interopRequireDefault(_wolfy87Eventemitter);

var _debug = require('debug');

var _debug2 = _interopRequireDefault(_debug);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var debug = (0, _debug2.default)('spin-bike:rpm-meter');

var PULSE_EVENT = exports.PULSE_EVENT = 'pulse';

var _class = function (_EventEmitter) {
	_inherits(_class, _EventEmitter);

	function _class() {
		var _ref = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

		var _ref$bufferSize = _ref.bufferSize;
		var bufferSize = _ref$bufferSize === undefined ? 512 : _ref$bufferSize;
		var _ref$numberOfInputCha = _ref.numberOfInputChannels;
		var numberOfInputChannels = _ref$numberOfInputCha === undefined ? 1 : _ref$numberOfInputCha;
		var _ref$numberOfOutputCh = _ref.numberOfOutputChannels;
		var numberOfOutputChannels = _ref$numberOfOutputCh === undefined ? 1 : _ref$numberOfOutputCh;

		_classCallCheck(this, _class);

		var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(_class).call(this));

		_this.initAudioScriptProcessor(bufferSize, numberOfInputChannels, numberOfOutputChannels);
		return _this;
	}

	_createClass(_class, [{
		key: 'getUserMedia',
		value: function getUserMedia() {
			return new Promise(function (resolve, reject) {
				(0, _getusermedia2.default)({
					audio: true,
					video: false
				}, function (err, stream) {
					if (err) {
						reject("Can't get user media (getUserMedia)");
					}

					resolve(stream);
				});
			});
		}
	}, {
		key: 'start',
		value: function start() {
			var _this2 = this;

			var _ref2 = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

			var _ref2$pulseThresholdR = _ref2.pulseThresholdRms;
			var pulseThresholdRms = _ref2$pulseThresholdR === undefined ? 0.1 : _ref2$pulseThresholdR;
			var _ref2$minSecondsBetwe = _ref2.minSecondsBetweenPulses;
			var minSecondsBetweenPulses = _ref2$minSecondsBetwe === undefined ? 0.2 : _ref2$minSecondsBetwe;

			this.pulseThresholdRms = pulseThresholdRms;
			this.minSecondsBetweenPulses = minSecondsBetweenPulses;

			this.isFirstPulse = true;
			this.lastPulseTimestamp = 0;

			return new Promise(function (resolve, reject) {
				_this2.getUserMedia().then(function (stream) {
					var microphone = _this2.audioContext.createMediaStreamSource(stream);

					microphone.connect(_this2.audioScriptProcessor);

					_this2.audioScriptProcessor.connect(_this2.audioContext.destination);

					resolve(function () {
						microphone.disconnect();

						_this2.audioScriptProcessor.disconnect();
					});
				}).catch(function (reason) {
					return reject(reason);
				});
			});
		}
	}, {
		key: 'initAudioScriptProcessor',
		value: function initAudioScriptProcessor(bufferSize, numberOfInputChannels, numberOfOutputChannels) {
			this.audioContext = _audioContext2.default;

			this.audioScriptProcessor = this.audioContext.createScriptProcessor(bufferSize, numberOfInputChannels, numberOfOutputChannels);

			this.audioScriptProcessor.onaudioprocess = this.handleAudioProcess.bind(this);
		}
	}, {
		key: 'handleAudioProcess',
		value: function handleAudioProcess(event) {
			var input = event.inputBuffer.getChannelData(0);

			var rms = this.getRms(input);

			if (!this.isPulse(rms)) {
				return;
			}

			if (this.isFirstPulse) {
				this.lastPulseTimestamp = _unixTimestamp2.default.now();
				this.isFirstPulse = false;

				return;
			}

			var currentPulseTimestamp = _unixTimestamp2.default.now();

			var secondsBetweenPulses = currentPulseTimestamp - this.lastPulseTimestamp;
			var rpm = this.calcRPM(secondsBetweenPulses);

			this.lastPulseTimestamp = currentPulseTimestamp;

			var pulseData = {
				'timestamp': currentPulseTimestamp,
				'secondsBetweenPulses': secondsBetweenPulses,
				'rpm': rpm
			};

			debug('Emitting pulse: ', pulseData);

			this.emit(PULSE_EVENT, pulseData);
		}
	}, {
		key: 'calcRPM',
		value: function calcRPM(secondsBetweenPulses) {
			return Math.floor(60 / secondsBetweenPulses);
		}
	}, {
		key: 'getRms',
		value: function getRms(inputBuffer) {
			var sum = 0.0;

			inputBuffer.forEach(function (data) {
				sum += data * data;
			});

			return Math.sqrt(sum / inputBuffer.length);
		}
	}, {
		key: 'isPulse',
		value: function isPulse(rms) {
			if (rms < this.pulseThresholdRms) {
				return false;
			}

			return _unixTimestamp2.default.now() - this.lastPulseTimestamp > this.minSecondsBetweenPulses;
		}
	}]);

	return _class;
}(_wolfy87Eventemitter2.default);

exports.default = _class;